#ifndef __snode__h
#define __snode__h

#include <stdio.h>
#include <math.h>

#ifndef ENTER_DATA_UTIL_H
#include "../../util/EnterDataUtil.h"
#endif

using namespace std;

  namespace SRTree { 
    
    class SNode {
      public:
	virtual ~SNode();
	virtual void range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) = 0;
	virtual int memory_usage() = 0;
	virtual void memory_usage(int &total, int &coords, int &ids, int &structure) = 0;
	virtual void addEntry(int cEntry, double l0, double l1, double h0, double h1, size_t ptr_id, int disc_factor,
		      double pl0, double pl1) = 0;

      protected:
	SNode(int _numEntries);
	
	int numEntries;
	//double* mbrs;
	int* data;
    };    
  }

#include "SNodeInt.h"
#include "SNodeLeaf.h"
#include "SNodeIntComp.h"
#include "SNodeLeafComp.h"
//#include "SNodeRDT.h"

#endif
