#include "SNodeInt.h"

SRTree::SNodeInt::SNodeInt(int _numEntries)
  : SNode(_numEntries) {
  children = new SNode* [numEntries];
}

SRTree::SNodeInt::~SNodeInt() {
  for(int i = 0; i < numEntries; i++)
    delete children[i];
  delete [] children;
}

void SRTree::SNodeInt::range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) {
  //double l0_, double l1_, double h0_, double h1_, 
  for(int i = 0; i < numEntries; i++) {
    int cL0 = data[5*i];
    int cL1 = data[5*i+1];
    int cH0 = data[5*i+2];
    int cH1 = data[5*i+3];

    /*
    double cL0_ = mbrs[4*i];
    double cL1_ = mbrs[4*i+1];
    double cH0_ = mbrs[4*i+2];
    double cH1_ = mbrs[4*i+3];
    int b1 = cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1;
    int b2 = cL0_ <= h0_ && cL1_ <= h1_ && cH0_ >= l0_ && cH1_ >= l1_;
    if(b1 != b2) printf("%d %d %d %d %d %d %lf %lf %lf %lf\n",b1,b2,data[5*i],data[5*i+1],data[5*i+2],data[5*i+3],mbrs[4*i],mbrs[4*i+1],mbrs[4*i+2],mbrs[4*i+3]);
    */
    
    if(cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1)
      ((SNode*)data[5*i+4])->range_query_disc(l0d, l1d, h0d, h1d, l0, l1, h0, h1, -1, -1, result, resultSize);
  }
}

void SRTree::SNodeInt::addEntry(int cEntry, double l0, double l1, double h0, double h1, size_t ptr_id, int disc_factor,
				double pl0, double pl1) {
/*  mbrs[4*cEntry] = l0;
  mbrs[4*cEntry+1] = l1;
  mbrs[4*cEntry+2] = h0;
  mbrs[4*cEntry+3] = h1;*/
  children[cEntry] = (SNode*)ptr_id;
  
  data[5*cEntry] = (int)round(l0*disc_factor);
  data[5*cEntry+1] = (int)round(l1*disc_factor);
  data[5*cEntry+2] = (int)round(h0*disc_factor);
  data[5*cEntry+3] = (int)round(h1*disc_factor);
  data[5*cEntry+4] = (int)ptr_id;
}

int SRTree::SNodeInt::memory_usage() {
  int total = sizeof(int) + numEntries*4*sizeof(int) + numEntries * sizeof(int);
  for(int i = 0; i < numEntries; i++) {
    total += children[i]->memory_usage();
  }
  return total;
}

void SRTree::SNodeInt::memory_usage(int &total, int &coords, int &ids, int &structure) {
  total += sizeof(int) + numEntries*4*sizeof(int) + numEntries * sizeof(int);
  coords += numEntries*4*sizeof(int);
  structure += sizeof(int) + numEntries * sizeof(int);
  for(int i = 0; i < numEntries; i++) {
    children[i]->memory_usage(total,coords,ids,structure);
  }
}
