#include "SNodeIntComp.h"

SRTree::SNodeIntComp::SNodeIntComp(int _numEntries)
  : SNode(_numEntries), compDataPos(0) {
  children = new SNode* [numEntries];
  _encoder = new ByteCodes();
  compData = new uint[5*numEntries];//TODO: compData should be moved to an array with the actual size
  for(int i = 0; i < 5*numEntries; i++) compData[i] = 0;
}

SRTree::SNodeIntComp::~SNodeIntComp() {
  for(int i = 0; i < numEntries; i++)
    delete children[i];
  delete [] children;
  delete [] compData;
  delete _encoder;
}

void SRTree::SNodeIntComp::range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) {
  //double l0_, double l1_, double h0_, double h1_, 
  int cPos = 0;
  for(int i = 0; i < numEntries; i++) {
    
    uint cL0,cL1,cH0,cH1,ptr;
    cPos += _encoder->decode(compData, cPos, &cL0);
    cPos += _encoder->decode(compData, cPos, &cL1);
    cPos += _encoder->decode(compData, cPos, &cH0);
    cPos += _encoder->decode(compData, cPos, &cH1);
    //cPos += _encoder->decode(compData, cPos, &ptr);
    cL0 += pl0;
    cL1 += pl1;
    cH0 += cL0;
    cH1 += cL1;
/*    int cL0 = data[5*i]+pl0;
    int cL1 = data[5*i+1]+pl1;
    int cH0 = data[5*i+2]+cL0;
    int cH1 = data[5*i+3]+cL1;*/
    pl0 = cL0;
    
    //printf("%d %d %d %d %d %d %lf %lf %lf %lf\n",cL0,cL1,data[5*i],data[5*i+1],data[5*i+2],data[5*i+3],mbrs[4*i],mbrs[4*i+1],mbrs[4*i+2],mbrs[4*i+3]);
    /*
    double cL0_ = mbrs[4*i];
    double cL1_ = mbrs[4*i+1];
    double cH0_ = mbrs[4*i+2];
    double cH1_ = mbrs[4*i+3];
    int b1 = cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1;
    int b2 = cL0_ <= h0_ && cL1_ <= h1_ && cH0_ >= l0_ && cH1_ >= l1_;
    if(b1 != b2) printf("%d %d %d %d %d %d %lf %lf %lf %lf\n",b1,b2,data[5*i],data[5*i+1],data[5*i+2],data[5*i+3],mbrs[4*i],mbrs[4*i+1],mbrs[4*i+2],mbrs[4*i+3]);
    */
    
    if(cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1)
      ((SNode*)data[5*i+4])->range_query_disc(l0d, l1d, h0d, h1d, l0, l1, h0, h1, cL0, cL1, result, resultSize);
  }
}

void SRTree::SNodeIntComp::addEntry(int cEntry, double l0, double l1, double h0, double h1, size_t ptr_id, int disc_factor,
				double pl0, double pl1) {
/*  mbrs[4*cEntry] = l0;
  mbrs[4*cEntry+1] = l1;
  mbrs[4*cEntry+2] = h0;
  mbrs[4*cEntry+3] = h1;*/
  children[cEntry] = (SNode*)ptr_id;
  
  data[5*cEntry] = (int)round((l0-pl0)*disc_factor);
  data[5*cEntry+1] = (int)round((l1-pl1)*disc_factor);
  data[5*cEntry+2] = (int)round((h0-l0)*disc_factor);
  data[5*cEntry+3] = (int)round((h1-l1)*disc_factor);
  data[5*cEntry+4] = (int)ptr_id;
  
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((l0-pl0)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((l1-pl1)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((h0-l0)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((h1-l1)*disc_factor));
  //compDataPos += _encoder->encode(compData, compDataPos, (uint)ptr_id);
}

int SRTree::SNodeIntComp::memory_usage() {
  int total = sizeof(int) + (compDataPos+31)/8 + numEntries * sizeof(int);
  for(int i = 0; i < numEntries; i++) {
    total += children[i]->memory_usage();
  }
  return total;
}

void SRTree::SNodeIntComp::memory_usage(int &total, int &coords, int &ids, int &structure) {
  total += sizeof(int) + (compDataPos+31)/8 + numEntries * sizeof(int);
  coords += (compDataPos+31)/8;
  structure += sizeof(int)+numEntries*sizeof(int);
  for(int i = 0; i < numEntries; i++) {
    children[i]->memory_usage(total,coords,ids,structure);
  }
}
