#include "SNodeLeaf.h"

SRTree::SNodeLeaf::SNodeLeaf(int _numEntries)
  : SNode(_numEntries) {
  ids = new long [numEntries];
}

SRTree::SNodeLeaf::~SNodeLeaf() {
  delete [] ids;
}

void SRTree::SNodeLeaf::range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) {
  for(int i = 0; i < numEntries; i++) {
    int cL0 = data[5*i];
    int cL1 = data[5*i+1];
    int cH0 = data[5*i+2];
    int cH1 = data[5*i+3];
    
    if(cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1)
      result[(*resultSize)++] = data[5*i+4];
  }
}

void SRTree::SNodeLeaf::addEntry(int cEntry, double l0, double l1, double h0, double h1, size_t ptr_id, int disc_factor,
				 double pl0, double pl1) {
/*  mbrs[4*cEntry] = l0;
  mbrs[4*cEntry+1] = l1;
  mbrs[4*cEntry+2] = h0;
  mbrs[4*cEntry+3] = h1;*/
  ids[cEntry] = (long)ptr_id;
  
  data[5*cEntry] = (int)round(l0*disc_factor);
  data[5*cEntry+1] = (int)round(l1*disc_factor);
  data[5*cEntry+2] = (int)round(h0*disc_factor);
  data[5*cEntry+3] = (int)round(h1*disc_factor);
  data[5*cEntry+4] = (int)ptr_id;
}

int SRTree::SNodeLeaf::memory_usage() {
  return sizeof(int) + numEntries*4*sizeof(int) + numEntries * sizeof(int);
}

void SRTree::SNodeLeaf::memory_usage(int &total, int &coords, int &ids, int &structure) {
  total += sizeof(int) + numEntries*4*sizeof(int) + numEntries * sizeof(int);
  coords += numEntries*4*sizeof(int);
  ids += numEntries * sizeof(int);
  structure += sizeof(int);
}