#include "SNodeLeafComp.h"

SRTree::SNodeLeafComp::SNodeLeafComp(int _numEntries)
  : SNode(_numEntries), compDataPos(0) {
  ids = new long [numEntries];
  _encoder = new ByteCodes();
  compData = new uint[5*numEntries];//TODO: compData should be moved to an array with the actual size
  for(int i = 0; i < 5*numEntries; i++) compData[i] = 0;
}

SRTree::SNodeLeafComp::~SNodeLeafComp() {
  delete [] ids;
  delete [] compData;
  delete _encoder;
}

void SRTree::SNodeLeafComp::range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) {
  int cPos = 0;
  for(int i = 0; i < numEntries; i++) {
    uint cL0,cL1,cH0,cH1,ptr;
    cPos += _encoder->decode(compData, cPos, &cL0);
    cPos += _encoder->decode(compData, cPos, &cL1);
    cPos += _encoder->decode(compData, cPos, &cH0);
    cPos += _encoder->decode(compData, cPos, &cH1);
    //cPos += _encoder->decode(compData, cPos, &ptr);
    cL0 += pl0;
    cL1 += pl1;
    cH0 += cL0;
    cH1 += cL1;
/*  int cL0 = data[5*i]+pl0;
    int cL1 = data[5*i+1]+pl1;
    int cH0 = data[5*i+2]+cL0;
    int cH1 = data[5*i+3]+cL1;*/
    pl0 = cL0;
    
    if(cL0 <= h0 && cL1 <= h1 && cH0 >= l0 && cH1 >= l1)
      result[(*resultSize)++] = data[5*i+4];
  }
}

void SRTree::SNodeLeafComp::addEntry(int cEntry, double l0, double l1, double h0, double h1, size_t ptr_id, int disc_factor,
				 double pl0, double pl1) {
/*  mbrs[4*cEntry] = l0;
  mbrs[4*cEntry+1] = l1;
  mbrs[4*cEntry+2] = h0;
  mbrs[4*cEntry+3] = h1;*/
  ids[cEntry] = (long)ptr_id;
  
  data[5*cEntry] = (int)round((l0-pl0)*disc_factor);
  data[5*cEntry+1] = (int)round((l1-pl1)*disc_factor);
  data[5*cEntry+2] = (int)round((h0-l0)*disc_factor);
  data[5*cEntry+3] = (int)round((h1-l1)*disc_factor);
  data[5*cEntry+4] = (int)ptr_id;

  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((l0-pl0)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((l1-pl1)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((h0-l0)*disc_factor));
  compDataPos += _encoder->encode(compData, compDataPos, (uint)round((h1-l1)*disc_factor));
  //compDataPos += _encoder->encode(compData, compDataPos, (uint)ptr_id);
}

int SRTree::SNodeLeafComp::memory_usage() {
  return sizeof(int) + (compDataPos+31)/8 + numEntries * sizeof(int);
}

void SRTree::SNodeLeafComp::memory_usage(int &total, int &coords, int &ids, int &structure) {
  total += sizeof(int) + (compDataPos+31)/8 + numEntries * sizeof(int);
  coords += (compDataPos+31)/8;
  ids += numEntries * sizeof(int);
  structure += sizeof(int);
}