#include "SNodeRDT.h"

#define BLOCK_SIZE 500

SRTree::SNodeRDT::SNodeRDT(int _numEntries, int scaleFactor, INPUT_MBR *input_data, uint input_size)
  : SNode(_numEntries) {

    localRDT = new rdt_wt(input_data, input_size, BLOCK_SIZE, "RICE", scaleFactor);
}

SRTree::SNodeRDT::~SNodeRDT() {
  delete localRDT;
}

void SRTree::SNodeRDT::range_query_disc(double l0d, double l1d, double h0d, double h1d, int l0, int l1, int h0, int h1, int pl0, int pl1, long* result, int* resultSize) {
  INPUT_MBR q;
  q.mbr.point1.lon = l0d;
  q.mbr.point1.lat = l1d;
  q.mbr.point2.lon = h0d;
  q.mbr.point2.lat = h1d;

  localRDT->executeQueryWT(&q, result, (uint*)resultSize);
}

int SRTree::SNodeRDT::memory_usage() {
  return localRDT->memoryUsage();
}
