#ifndef __srtree__h
#define __srtree__h

#define SRTREE_TYPE_REG 1
#define SRTREE_TYPE_COMP 2
#define SRTREE_TYPE_HYB 3

#include <iostream>

#include <SpatialIndex.h>
#include <RTreeH.h>

#include "SNode.h"

using namespace std;
using namespace SRTree;

namespace SpatialIndex {
  namespace RTree { 
    
    class SRTree {
      public:
	SRTree(RTree* _tree, uint _disc_factor, int _index_type, uint param);
	void range_query(double l0, double l1, double h0, double h1, long* result, int* resultSize);
	
	uint memory_usage();
	void memory_usage(int &total, int &coords, int &ids, int &structure);
	uint getNumObj() {return numObj;}
	
      protected:
	SNode* createNode(RTree* _tree, NodePtr cNode, uint param);
	void collectMBRs(RTree* _tree, NodePtr cNode, vector <INPUT_MBR> &collector);
	
	SNode *root;
	uint disc_factor;
	
	uint numObj;
	uint numEntriesPerNode;
	int index_type;
	
	int lower0, lower1;
    };
    

  }
}

#endif
